/*
  Widge Name: Flags, v1.7.2
    (c) 2005 Hawk Innovations

  1.3: Added preference, choice of larger image
  1.4: Updated gifURL
  1.5: Updated URL, fixed Nepal
  1.6: Removed Serbia and Montenegro, added them as separate country
  1.7: Updated to new CIA links
  1.7.1: Updated new info links (use uppercase)
  1.7.2: Updated new map, info link (use lowercase)
*/

var gifURL;
var infoURL;
var fsx, fsy;

function showFlag()
{
  var x = document.getElementById('listf').value;
  if (x == 'none') {
    document.getElementById("flagGIF").width = 120;
    document.getElementById("flagGIF").src = "images/Startmsg.png";
    infoURL = "";
  } else {
    document.getElementById("flagGIF").width = fsx;
//    document.getElementById("flagGIF").src = gifURL + x.substr(8,2) + "-flag.gif";
//    document.getElementById("flagGIF").src = gifURL + x.substr(8,2) + "-lgflag.gif";
    document.getElementById("flagGIF").src = gifURL + x.substr(8,2) + "-lgflag.gif";
    //infoURL = "http://www.odci.gov/cia/publications/factbook/geos/" + x.substr(8,2) + ".html";
    //infoURL = "https://www.cia.gov/cia/publications/factbook/geos/" + x.substr(8,2) + ".html";
    //infoURL = "https://www.cia.gov/library/publications/the-world-factbook/geos/" + x.substr(8,2) + ".html";
    //infoURL = "https://www.cia.gov/library/publications/the-world-factbook/geos/" + x.substr(8,2).toUpperCase() + ".html";
    infoURL = "https://www.cia.gov/library/publications/the-world-factbook/geos/" + x.substr(8,2).toLowerCase() + ".html";
  }
}

function showInfo() 
{
  if (infoURL != "") 
    widget.openURL(infoURL);
}

function setup()
{
    //gifURL = "http://www.odci.gov/cia/publications/factbook/flags/";
//    gifURL = "https://www.cia.gov/library/publications/the-world-factbook/graphics/flags/small/";
//    gifURL = "https://www.cia.gov/library/publications/the-world-factbook/graphics/flags/resize/";
gifURL = "https://www.cia.gov/library/publications/the-world-factbook/graphics/flags/large/";
    infoURL = "";

    var country = widget.preferenceForKey("country");
    var large =  widget.preferenceForKey("large");
    if (large == "true") {
      document.getElementById("flagsize").checked = true;
      fsx = 360; fsy = 240;
    } else {
      fsx = 120; fsy = 80;
    } 
    if (country != "") {
      document.getElementById('listf').selectedIndex = country;
    }
var x = document.getElementById('listf').value;
if (x.substr(8,2) == "np" && large) {
	fsx = 240; fsy = 800;
} if (x.substr(8,2) == "np" && !large) {
	fsx = 120; fsy = 400;
}
      window.resizeTo(fsx, fsy);


    createGenericButton(document.getElementById('doneButton'), 'Done', hideBack);

    if (window.widget)
    {
        widget.onshow = onshow;
        widget.onhide = onhide;
    }
    showFlag();
}

function showBack()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) {
		window.resizeTo(220, 110);
		widget.prepareForTransition("ToBack");
	}

	front.style.display="none";
	back.style.display="block";

	if (window.widget) setTimeout ('widget.performTransition();', 0);  
	
}

function hideBack()
{
  mouseexit(event);
  var front = document.getElementById("front");
  var back = document.getElementById("back");

  var sz = document.getElementById("flagsize").checked;
  if (sz) {
    fsx = 360; fsy = 240;
    widget.setPreferenceForKey("true", "large");
  } else {
    fsx = 120; fsy = 80;
    widget.setPreferenceForKey("false", "large");
  }
  var c = document.getElementById('listf').selectedIndex;
  widget.setPreferenceForKey(c, "country");

var x = document.getElementById('listf').value;
if (x.substr(8,2) == "np" && sz) {
	fsx = 240; fsy = 800;
} if (x.substr(8,2) == "np" && !sz) {
	fsx = 120; fsy = 400;
}

  if (window.widget) {
     window.resizeTo(fsx, fsy);
     widget.prepareForTransition("ToFront");
  }

  back.style.display="none";
  front.style.display="block";

  if (window.widget){
    setTimeout ('widget.performTransition();', 0);
  }
  document.getElementById('fliprollie').style.display = 'none';

    
  showFlag();
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function onhide()
{
}

function onshow()
{
}
